/* (c) Peter Mueller, 2014 - All rights reserved. Reproduction, modification,
   use or disclosure to third parties without express
   authority is forbidden. Generator running in demo mode!
   Please purchase a license if you want to use this software in projects.
 */

/* Command line options: -p EA -A -t Model:implementation_model:modbus_client -o modbus_client modbus_client.xml   */
/* This file is generated from modbus_client.xml - do not edit manually  */
/* Generated on: Sun Jun 22 14:29:04 CEST 2014 / version 3.6.5 */



/* User defined header text  */
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include <modbus.h>
#include "modbus_client_defines.h"

// local variables
modbus_t *ctx;
uint16_t lineVoltages[3]={0,0,0};
uint16_t realpower[3]={0,0,0};
uint16_t totalPowerT1[2]={0,0};
int16_t rc;
unsigned long lTotalPower=0;
float fTotalPower=0;
int retCode = 0;


/*Enumeration of all node names */
typedef enum {
	ACTIVITY_ACTIVITYINITIAL,
	ACTIVITY_RETURNERROR,
	ACTIVITY_RETURNOK,
	ACTIVITY_CHECK_FOR_READ_ERROR,
	ACTIVITY_CHECK_MODBUS_RET_CODE,
	ACTIVITY_CHECK_RIGHT_NUMBER_OF_ARGUMENTS,
	ACTIVITY_CONNECT_ERROR,
	ACTIVITY_CONNECT_TO_SLAVE,
	ACTIVITY_OPEN_MODBUS_LIB,
	ACTIVITY_PRINT_CONNECT_ERROR,
	ACTIVITY_PRINT_LIB_OPEN_ERROR_MESSAGE,
	ACTIVITY_PRINT_READ_ERROR,
	ACTIVITY_PRINT_REQUESTED_VALUE,
	ACTIVITY_PRINT_WRONG_NUMBER_OF_ARG_ERROR_MESSAGE,
	ACTIVITY_READ_MULTIPLE_REGISTERS,
	ACTIVITY_RELEASE_LIB,
	ACTIVITY_SET_ERROR_CODE,
	ACTIVITY_SET_SLAVE_ADDR,
	ACTIVITY,__END__,
} BRANCHES;


int activity(int argc, char* argv[]){

	BRANCHES id;

	if(argc!=3){
		id = ACTIVITY_PRINT_WRONG_NUMBER_OF_ARG_ERROR_MESSAGE;
	}else{
		id = ACTIVITY_OPEN_MODBUS_LIB;
	}
	while(id != __END__) { 
		switch(id) {
			case ACTIVITY_RETURNERROR:
				id= __END__;
				break;

			case ACTIVITY_RETURNOK:
				id= __END__;
				break;

			case ACTIVITY_CONNECT_TO_SLAVE:
				rc=modbus_connect(ctx);
				if(rc == -1){
					id = ACTIVITY_PRINT_CONNECT_ERROR;
				}else{
					id = ACTIVITY_READ_MULTIPLE_REGISTERS;
				}
				break;

			case ACTIVITY_OPEN_MODBUS_LIB:
				ctx = modbus_new_rtu(argv[1], 19200, 'E', 8, 1);
				if(ctx==NULL){
					id = ACTIVITY_PRINT_LIB_OPEN_ERROR_MESSAGE;
				}else{
					id = ACTIVITY_SET_SLAVE_ADDR;
				}
				break;

			case ACTIVITY_PRINT_CONNECT_ERROR:
				fprintf(stderr, "Connection failed: %s\n", modbus_strerror(errno));
				id=ACTIVITY_RELEASE_LIB;
				break;

			case ACTIVITY_PRINT_LIB_OPEN_ERROR_MESSAGE:
				fprintf(stderr, "Unable to allocate libmodbus context\n");
				id=ACTIVITY_SET_ERROR_CODE;
				break;

			case ACTIVITY_PRINT_READ_ERROR:
				fprintf(stderr,"FAILED (nb points %d)\n", rc);
				id=ACTIVITY_SET_ERROR_CODE;
				break;

			case ACTIVITY_PRINT_REQUESTED_VALUE:
				if(strcmp(argv[2],"VOLTAGE")==0){
					printf("PUTVAL \"/ENERGIE/UL1\" N:%d\n",lineVoltages[0]);
					printf("PUTVAL \"/ENERGIE/UL2\" N:%d\n",lineVoltages[1]);
					printf("PUTVAL \"/ENERGIE/UL3\" N:%d\n",lineVoltages[2]);
				}else if(strcmp(argv[2],"PWR")==0){
					lTotalPower = totalPowerT1[0]*65536+totalPowerT1[1];
					fTotalPower = ((float) lTotalPower);
					
					printf("PUTVAL \"/PWR_L1/power\" N:%d\n",realpower[0]*10);
					printf("PUTVAL \"/PWR_L2/power\" N:%d\n",realpower[1]*10);
					printf("PUTVAL \"/PWR_L3/power\" N:%d\n",realpower[2]*10);
					printf("PUTVAL \"/PWR_TOT1/power\" N:%f\n",fTotalPower/100);
				}else{
					fprintf(stderr,"wrong command\n");
				}
				id=ACTIVITY_RETURNOK;
				break;

			case ACTIVITY_PRINT_WRONG_NUMBER_OF_ARG_ERROR_MESSAGE:
				fprintf(stderr,"wrong command\n");
				id=ACTIVITY_SET_ERROR_CODE;
				break;

			case ACTIVITY_READ_MULTIPLE_REGISTERS:
				rc = modbus_read_registers(ctx, REG_UL1-1, 1, &lineVoltages[0]); // uses fc3
				rc |= modbus_read_registers(ctx, REG_UL2-1, 1, &lineVoltages[1]);
				rc |= modbus_read_registers(ctx, REG_UL3-1, 1, &lineVoltages[2]);
				rc |= modbus_read_registers(ctx, REG_REAL_PWR_L1-1, 1, &realpower[0]);
				rc |= modbus_read_registers(ctx, REG_REAL_PWR_L2-1, 1, &realpower[1]);
				rc |= modbus_read_registers(ctx, REG_REAL_PWR_L3-1, 1, &realpower[2]);
				rc |= modbus_read_registers(ctx, REG_T1_TOT-1, 1, &totalPowerT1[0]);
				rc |= modbus_read_registers(ctx, REG_T1_TOT, 1, &totalPowerT1[1]);
				if(rc!=1){
					id = ACTIVITY_PRINT_READ_ERROR;
				}else{
					id = ACTIVITY_PRINT_REQUESTED_VALUE;
				}
				break;

			case ACTIVITY_RELEASE_LIB:
				modbus_free(ctx);
				id=ACTIVITY_SET_ERROR_CODE;
				break;

			case ACTIVITY_SET_ERROR_CODE:
				retCode = -1;
				id=ACTIVITY_RETURNERROR;
				break;

			case ACTIVITY_SET_SLAVE_ADDR:
				modbus_set_slave(ctx, SERVER_ID);
				id=ACTIVITY_CONNECT_TO_SLAVE;
				break;

			default:
				break;

		}
	}
	return retCode ;
}


